## hatari 2.2.0+dfsg

=== doc/CMakeLists.txt ===

INSTALL(FILES authors.txt emutos.txt keymap-sample.txt memory-usage.txt
	midi-linux.txt release-notes.txt todo.txt
	DESTINATION ${DOCDIR})

INSTALL(FILES compatibility.html  manual.html
	DESTINATION ${DOCDIR})

INSTALL(DIRECTORY images
	DESTINATION ${DOCDIR})

if(NOT WIN32)
	add_custom_target(manpages ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hatari.1 > ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz
		DEPENDS hatari.1)
	INSTALL(FILES  ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz DESTINATION ${MANDIR})
endif()

find_program(TIDY tidy)
if(TIDY)
	add_test(NAME tidy-manual
	         COMMAND tidy -q -e ${CMAKE_CURRENT_SOURCE_DIR}/manual.html)
	add_test(NAME tidy-compatibility
	         COMMAND tidy -q -e ${CMAKE_CURRENT_SOURCE_DIR}/compatibility.html)
endif()

=== tools/CMakeLists.txt ===

add_subdirectory(hmsa)

include(FindPythonInterp)
if(PYTHONINTERP_FOUND)
	add_subdirectory(hconsole)
	add_subdirectory(debugger)
endif(PYTHONINTERP_FOUND)

install(PROGRAMS atari-convert-dir.py DESTINATION ${BINDIR} RENAME atari-convert-dir)
install(PROGRAMS hatari-prg-args.sh DESTINATION ${BINDIR} RENAME hatari-prg-args)
install(PROGRAMS atari-hd-image.sh DESTINATION ${BINDIR} RENAME atari-hd-image)
install(PROGRAMS zip2st.sh DESTINATION ${BINDIR} RENAME zip2st)

if(NOT WIN32)
	add_custom_target(atari_convert_dir_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/atari-convert-dir.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/atari-convert-dir.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/atari-convert-dir.1 > ${CMAKE_CURRENT_BINARY_DIR}/atari-convert-dir.1.gz
		DEPENDS atari-convert-dir.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/atari-convert-dir.1.gz DESTINATION ${MANDIR})

	add_custom_target(hatari_prg_args_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hatari-prg-args.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hatari-prg-args.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hatari-prg-args.1 > ${CMAKE_CURRENT_BINARY_DIR}/hatari-prg-args.1.gz
		DEPENDS hatari-prg-args.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hatari-prg-args.1.gz DESTINATION ${MANDIR})

	add_custom_target(atari_hd_image_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/atari-hd-image.1 > ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz
		DEPENDS atari-hd-image.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz DESTINATION ${MANDIR})

	add_custom_target(zip2st_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/zip2st.1 > ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz
		DEPENDS zip2st.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz DESTINATION ${MANDIR})
endif()

=== src/debug/CMakeLists.txt ===

if(READLINE_FOUND)
	include_directories(${READLINE_INCLUDE_DIR})
endif(READLINE_FOUND)

if(ENABLE_DSP_EMU)
	set(DSPDBG_C debugdsp.c)
endif(ENABLE_DSP_EMU)

add_library(Debug
	    log.c debugui.c breakcond.c debugcpu.c debugInfo.c
	    ${DSPDBG_C} evaluate.c history.c symbols.c vars.c
	    profile.c profilecpu.c profiledsp.c
	    natfeats.c console.c 68kDisass.c)

=== src/falcon/CMakeLists.txt ===

if(PORTAUDIO_FOUND)
	include_directories(${PORTAUDIO_INCLUDE_DIR})
endif(PORTAUDIO_FOUND)

if(ENABLE_DSP_EMU)
	set(DSP_SOURCES dsp_core.c dsp_cpu.c dsp_disasm.c)
endif(ENABLE_DSP_EMU)

add_library(Falcon
	    crossbar.c microphone.c nvram.c videl.c dsp.c ${DSP_SOURCES})

=== tests/serial/CMakeLists.txt ===

set(testrunner ${CMAKE_CURRENT_SOURCE_DIR}/run_test.sh)

foreach(machine st ste tt)
    add_test(NAME serial-mfp-${machine}
             COMMAND ${testrunner} $<TARGET_FILE:hatari> mfp ${machine})
endforeach(machine)

foreach(machine megaste tt falcon)
    add_test(NAME serial-scc-${machine}
             COMMAND ${testrunner} $<TARGET_FILE:hatari> scc ${machine})
endforeach(machine)

if(NOT PORTMIDI_FOUND)
    foreach(machine st ste tt falcon)
        add_test(NAME serial-midi-${machine}
                 COMMAND ${testrunner} $<TARGET_FILE:hatari> midi ${machine})
    endforeach(machine)
endif(NOT PORTMIDI_FOUND)

=== tools/debugger/CMakeLists.txt ===

include_directories(${SDL_INCLUDE_DIR})

add_executable(gst2ascii gst2ascii.c)

install(TARGETS gst2ascii RUNTIME DESTINATION ${BINDIR})

install(PROGRAMS hatari_profile.py DESTINATION ${BINDIR} RENAME hatari_profile)

# if(UNIX)
	add_custom_target(gst2ascii_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gst2ascii.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gst2ascii.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/gst2ascii.1 > ${CMAKE_CURRENT_BINARY_DIR}/gst2ascii.1.gz
		DEPENDS gst2ascii.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/gst2ascii.1.gz DESTINATION ${MANDIR})

	add_custom_target(hatari_profile_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hatari_profile.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hatari_profile.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hatari_profile.1 > ${CMAKE_CURRENT_BINARY_DIR}/hatari_profile.1.gz
		DEPENDS hatari_profile.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hatari_profile.1.gz DESTINATION ${MANDIR})
# endif(UNIX)

=== tools/hconsole/CMakeLists.txt ===

INSTALL(PROGRAMS hconsole.py example.py
	DESTINATION ${DATADIR}/hconsole/)

# files related to example.py
INSTALL(FILES example-commands example-debugger
	DESTINATION ${DATADIR}/hconsole/)

# documentation
INSTALL(FILES release-notes.txt
	DESTINATION ${DATADIR}/hconsole/)

# if(UNIX)
	add_custom_target(hconsole_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hconsole.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hconsole.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hconsole.1 > ${CMAKE_CURRENT_BINARY_DIR}/hconsole.1.gz
		DEPENDS hconsole.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hconsole.1.gz DESTINATION ${MANDIR})
# endif(UNIX)

=== tools/hmsa/CMakeLists.txt ===

include_directories(${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/src/includes
		    ${CMAKE_SOURCE_DIR}/src/debug ${SDL_INCLUDE_DIR})

set(HMSA_SOURCES hmsa.c floppy.c ../../src/file.c)

if(ZLIB_FOUND)
	include_directories(${ZLIB_INCLUDE_DIR})
	set(HMSA_SOURCES ${HMSA_SOURCES}  ../../src/unzip.c)
endif(ZLIB_FOUND)

add_executable(hmsa ${HMSA_SOURCES})

target_link_libraries(hmsa Floppy)

if(MATH_FOUND)
	target_link_libraries(hmsa ${MATH_LIBRARY})
endif(MATH_FOUND)

if(ZLIB_FOUND)
	target_link_libraries(hmsa ${ZLIB_LIBRARY})
endif(ZLIB_FOUND)

install(TARGETS hmsa RUNTIME DESTINATION ${BINDIR})

# if(UNIX)
	add_custom_target(hmsa_manpage ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hmsa.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hmsa.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hmsa.1 > ${CMAKE_CURRENT_BINARY_DIR}/hmsa.1.gz
		DEPENDS hmsa.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hmsa.1.gz DESTINATION ${MANDIR})
# endif(UNIX)

=== debian/changelog ===
hatari (2.2.0+dfsg-1) unstable; urgency=medium

  * Import upstream version 2.2.0
  * Bump debhelper compatibility level to 12
  * Add Rules-Requires-Root: no
  * Build with python3, force python3 shebang
  * Drop 03-fix-py-extension, applied upstream
  * Refresh patch 06-fix-typo-in-manpage
  * Add new patch fixing installation of python-ui documentation
  * Update copyright information
  * Update README.Debian, WinUAE CPU core is now the default
  * Bump standards-version, no changes required
  * Add patch for using py3 for gentypes during build
  * Disable test suite for now
  * Run wrap-and-sort -ast

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Thu, 31 Jan 2019 22:33:28 +0100

=== debian/control ===
Source: hatari
Section: otherosfs
Priority: optional
Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 dh-python,
 libpng-dev,
 libreadline-dev,
 libsdl2-dev,
 portaudio19-dev,
 python3,
 zlib1g-dev,
Standards-Version: 4.3.0
Rules-Requires-Root: no
Homepage: http://hatari.tuxfamily.org/

Package: hatari
Architecture: any
Depends:
 gir1.2-gtk-3.0,
 python3-gi,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 binfmt-support,
Suggests:
 dosfstools,
 mtools,
 unzip,
Description: Emulator for the Atari ST, STE, TT, and Falcon computers
 Hatari is an emulator for the Atari ST line of computers.
 .
 The Atari ST was a 16/32 bit computer system which was first released by
 Atari in 1985. Using the Motorola 68000 CPU, it was a very popular computer
 having quite a lot of CPU power at that time.
 .
 Unlike many other Atari ST emulators which try to give you a good environment
 for running GEM applications, Hatari tries to emulate the hardware of a ST as
 close as possible so that it is able to run most of the old ST games and
 demos.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS=1
include /usr/share/dpkg/buildflags.mk

LDFLAGS += -Wl,--as-needed
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --buildsystem=cmake --builddirectory=build --with=python3

override_dh_auto_configure:
	 dh_auto_configure -O--buildsystem=cmake \
	   -O--builddirectory=build \
	   -- \
	   -DCMAKE_COLOR_MAKEFILE:BOOL=0 \
	   -DCMAKE_C_FLAGS:STRING="$(CFLAGS)" \
	   -DCMAKE_CXX_FLAGS:STRING="$(CXXFLAGS)" \
	   -DCMAKE_LINK_FLAGS:STRING="$(LDFLAGS)"

override_dh_auto_build:
	dh_auto_build -O--buildsystem=cmake -O--builddirectory=build

override_dh_install:
	dh_install --sourcedir=build

	# Remove bundled EmuTOS image
	#-rm debian/hatari/usr/share/hatari/tos.img

	# Install binfmt support for atari binaries
	install -m644 -D debian/binfmt debian/hatari/usr/share/binfmts/hatari

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

override_dh_auto_test:
	true

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=cmake -O--builddir=build
	find . -name *.pyc -exec rm -f {} \;

=== debian/watch ===
version=3
        opts=dversionmangle=s/\+dfsg\d//,uversionmangle=s/(.*)/$1+dfsg/ \
        https://download.tuxfamily.org/hatari/(\d\.\d\.\d)/hatari-(.*).tar.bz2

## hatari 2.2.1%2Bdfsg

=== src/cpu/CMakeLists.txt ===

include_directories(. ../.. ../includes ${SDL_INCLUDE_DIR} softfloat)

# The sources generated by gencpu:
set(CPUEMU_SRCS cpustbl.c cpuemu_0.c cpuemu_11.c cpuemu_13.c
		cpuemu_20.c cpuemu_21.c cpuemu_22.c cpuemu_23.c cpuemu_24.c
		cpuemu_31.c cpuemu_32.c cpuemu_33.c cpuemu_34.c cpuemu_35.c
		cpuemu_40.c cpuemu_50.c)

# Sources that are synchronized with WinUAE:
set(WINUAE_SRCS cpudefs.c cpummu.c cpummu030.c debug.c newcpu_common.c newcpu.c
		readcpu.c writelog.c fpp.c fpp_native.c fpp_softfloat.c
		softfloat/softfloat.c softfloat/softfloat_decimal.c
		softfloat/softfloat_fpsp.c machdep/m68k.c)

# Unfortunately we've got to specify the rules for the generated files twice,
# once for cross compiling (with calling the host cc directly) and once
# for native compiling so that the rules also work for non-Unix environments...
if(CMAKE_CROSSCOMPILING)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/build68k
		COMMAND cc -I${CMAKE_CURRENT_SOURCE_DIR}
			   ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c
			   ${CMAKE_CURRENT_SOURCE_DIR}/writelog.c
			   -o ${CMAKE_CURRENT_BINARY_DIR}/build68k
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND ./build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/table68k
			${CMAKE_CURRENT_BINARY_DIR}/build68k)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		COMMAND cc -I${CMAKE_CURRENT_SOURCE_DIR}
			   cpudefs.c ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			   ${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c
			   -o ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c cpudefs.c)

	add_custom_command(OUTPUT ${CPUEMU_SRCS}
		COMMAND ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gencpu)

else()	# Rules for normal build follow

	add_executable(build68k build68k.c writelog.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS table68k build68k)

	add_executable(gencpu gencpu.c readcpu.c cpudefs.c)

	add_custom_command(OUTPUT ${CPUEMU_SRCS} COMMAND gencpu  DEPENDS gencpu)

endif(CMAKE_CROSSCOMPILING)

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
	# Silence some warnings for the autogenerated sources - the generated
	# cpuemu_xx.c contains a lot of warnings we don't really care about...
	set(CPUEMU_CFLAGS "-Wno-sign-compare -Wno-shadow -Wno-unused-variable")
	if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.6)
		set (CPUEMU_CFLAGS "${CPUEMU_CFLAGS} -Wno-unused-but-set-variable")
	endif()
	set_source_files_properties(${CPUEMU_SRCS}
		PROPERTIES COMPILE_FLAGS ${CPUEMU_CFLAGS})

	# For the other files, hide some harmless warnings, too (since we
	# try to keep the files in sync with WinUAE, it's hard to fix them)
	set(CPUMAIN_CFLAGS "-Wno-unused-variable -Wno-unused-function -Wno-unused-label")
	if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.6)
		set (CPUMAIN_CFLAGS "${CPUMAIN_CFLAGS} -Wno-unused-but-set-variable")
	endif()
	# The remaining warnings should be hidden for release builds:
	if (CMAKE_BUILD_TYPE STREQUAL "Release")
		set(CPUMAIN_CFLAGS "${CPUMAIN_CFLAGS} -Wno-sign-compare -Wno-bad-function-cast")
		set(CPUMAIN_CFLAGS "${CPUMAIN_CFLAGS} -Wno-missing-braces")
		if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.7)
			set(CPUMAIN_CFLAGS "${CPUMAIN_CFLAGS} -Wno-maybe-uninitialized")
		endif()
	endif()
	set_source_files_properties(${WINUAE_SRCS}
		PROPERTIES COMPILE_FLAGS ${CPUMAIN_CFLAGS})
endif()

add_library(UaeCpu ${CPUEMU_SRCS} ${WINUAE_SRCS} custom.c events.c memory.c
		   hatari-glue.c)

=== tests/debugger/CMakeLists.txt ===

if(ENABLE_WINUAE_CPU)
	set(CPUDIR ${CMAKE_SOURCE_DIR}/src/cpu)
else()
	set(CPUDIR ${CMAKE_SOURCE_DIR}/src/uae-cpu)
endif(ENABLE_WINUAE_CPU)

set(TEST_SOURCE_DIR ${CMAKE_SOURCE_DIR}/tests/debugger)

include_directories(${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/src/includes
		    ${CMAKE_SOURCE_DIR}/src/debug ${CMAKE_SOURCE_DIR}/src/falcon
		    ${CMAKE_SOURCE_DIR}/src/debug ${SDL_INCLUDE_DIR} ${CPUDIR})

add_library(DebuggerTestLib test-dummies.c  ${CMAKE_SOURCE_DIR}/src/str.c
	    ${CMAKE_SOURCE_DIR}/src/debug/breakcond.c
	    ${CMAKE_SOURCE_DIR}/src/debug/debugcpu.c
	    ${CMAKE_SOURCE_DIR}/src/debug/history.c
	    ${CMAKE_SOURCE_DIR}/src/debug/evaluate.c
	    ${CMAKE_SOURCE_DIR}/src/debug/symbols.c
	    ${CMAKE_SOURCE_DIR}/src/debug/vars.c)

add_executable(test-breakcond test-breakcond.c)
target_link_libraries(test-breakcond DebuggerTestLib)
add_test(NAME debugger-breakcond WORKING_DIRECTORY ${TEST_SOURCE_DIR}
         COMMAND test-breakcond)

add_executable(test-evaluate test-evaluate.c)
target_link_libraries(test-evaluate DebuggerTestLib)
add_test(NAME debugger-evaluate WORKING_DIRECTORY ${TEST_SOURCE_DIR}
         COMMAND test-evaluate)

add_executable(test-symbols test-symbols.c)
target_link_libraries(test-symbols DebuggerTestLib)
add_test(NAME debugger-symbols WORKING_DIRECTORY ${TEST_SOURCE_DIR}
         COMMAND test-symbols)

=== debian/control ===
--- 
+++ 
@@ -2,34 +2,30 @@
 Section: otherosfs
 Priority: optional
 Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
-Build-Depends:
- cmake,
- debhelper-compat (= 12),
- dh-python,
- libpng-dev,
- libreadline-dev,
- libsdl2-dev,
- portaudio19-dev,
- python3,
- zlib1g-dev,
+Build-Depends: cmake,
+               debhelper-compat (= 12),
+               dh-python,
+               libpng-dev,
+               libreadline-dev,
+               libsdl2-dev,
+               portaudio19-dev,
+               python3,
+               zlib1g-dev,
 Standards-Version: 4.3.0
 Rules-Requires-Root: no
 Homepage: http://hatari.tuxfamily.org/
 
 Package: hatari
 Architecture: any
-Depends:
- gir1.2-gtk-3.0,
- python3-gi,
- ${misc:Depends},
- ${python3:Depends},
- ${shlibs:Depends},
-Recommends:
- binfmt-support,
-Suggests:
- dosfstools,
- mtools,
- unzip,
+Depends: gir1.2-gtk-3.0,
+         python3-gi,
+         ${misc:Depends},
+         ${python3:Depends},
+         ${shlibs:Depends},
+Recommends: binfmt-support,
+Suggests: dosfstools,
+          mtools,
+          unzip,
 Description: Emulator for the Atari ST, STE, TT, and Falcon computers
  Hatari is an emulator for the Atari ST line of computers.
  .

## hatari 2.2.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8 FATAL_ERROR)

project(Hatari C)
enable_testing()

set(APP_NAME "Hatari")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckStructHasMember)
include(CheckCCompilerFlag)
include(DistClean)
include(CheckTypeSize)

# Set build type to "Release" if user did not specify any build type yet
# Other possible values: Debug, Release, RelWithDebInfo and MinSizeRel
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release)
endif(NOT CMAKE_BUILD_TYPE)

# set(CMAKE_VERBOSE_MAKEFILE 1)


######################################################################
# Check if Large File Support is available
# We test if the size of the type 'off_t' is at least 8 bytes
######################################################################

function (check_large_file)
	set (CMAKE_REQUIRED_FLAGS ${HATARI_LFS_FLAGS} )
	check_type_size("off_t" SIZEOF_OFF_T )

	if ( SIZEOF_OFF_T GREATER 7 )
		message ( "   -> Size of off_t=${SIZEOF_OFF_T}, Large File Support is available" )
		set ( HATARI_HAVE_LFS 1 CACHE INTERNAL "Large file Support" )
	else()
		message ( "   -> Size of off_t=${SIZEOF_OFF_T}, Large File Support is not available" )
		set ( HATARI_HAVE_LFS 0 CACHE INTERNAL "Large file Support" )
	endif()
endfunction (check_large_file)



# ##########################
# Conditional build features
# ##########################

set(ENABLE_SDL2 1
    CACHE BOOL "Enable building with libSDL2 instead of v1.2")
set(ENABLE_DSP_EMU 1
    CACHE BOOL "Enable DSP 56k emulator for Falcon mode")
set(ENABLE_TRACING 1
    CACHE BOOL "Enable tracing messages for debugging")
set(ENABLE_SMALL_MEM 0
    CACHE BOOL "Enable to use less memory - at the expense of emulation speed")
set(ENABLE_WINUAE_CPU 1
    CACHE BOOL "Enable WinUAE CPU core")

# Run-time checks with GCC "mudflap" etc features:
# - stack protection
# - checking of pointer accesses
#
# Before running CMake, install "mudflap" library development package
# (libmudflap0-4.4-dev in Debian Squeeze and libmudflap-devel in Fedora).
#
# After this you can configure Hatari with Mudflap:
#   cd build; make clean; cmake -D ENABLE_MUDFLAP:BOOL=1 -D ..
# If everything's fine, CMake output should include:
#   Performing Test MUDFLAP_AVAILABLE - Success"
#
# After (re-)building Hatari, run it with something like this:
#   MUDFLAP_OPTIONS="-viol-gdb" src/hatari --sound off --mic off
# (sound&mic are disabled because threading doesn't work well with Mudflap)
#
# For more info:
#   http://gcc.gnu.org/wiki/Mudflap_Pointer_Debugging
#
set(CMAKE_REQUIRED_LIBRARIES "mudflap")
CHECK_C_COMPILER_FLAG("-fmudflapth" MUDFLAP_AVAILABLE)
set(CMAKE_REQUIRED_LIBRARIES "")
if(MUDFLAP_AVAILABLE)
	set(ENABLE_MUDFLAP 0
	    CACHE BOOL "Enable GCC run-time stack/pointer debugging - with huge slowdown")
endif(MUDFLAP_AVAILABLE)

if(APPLE)
	set(ENABLE_OSX_BUNDLE 1
	    CACHE BOOL "Built Hatari as macOS application bundle")
	# set(CMAKE_OSX_ARCHITECTURES "i386" CACHE STRING "Target architectures" FORCE)
	# set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.6.sdk" CACHE STRING "10.6 SDK" FORCE)
	# set(CMAKE_OSX_DEPLOYMENT_TARGET "10.5" CACHE STRING "Target Min 10.5" FORCE)
	set(ADDITIONAL_INCLUDES ${FRAMEWORKS})
	set_source_files_properties(${FRAMEWORKS} PROPERTIES MACOSX_PACKAGE_LOCATION Frameworks)
else()
	set(ENABLE_OSX_BUNDLE 0
	    CACHE BOOL "Built Hatari as macOS application bundle")
endif(APPLE)

# ####################
# Check for libraries:
# ####################

if(ENABLE_SDL2)
	find_package(SDL2)
	#if(NOT SDL2_FOUND)
	#	message(FATAL_ERROR "SDL2 library not found!")
	#endif(NOT SDL2_FOUND)
	set(SDL_INCLUDE_DIR ${SDL2_INCLUDE_DIR})
	set(SDL_LIBRARY ${SDL2_LIBRARY})
	set(SDLMAIN_LIBRARY ${SDL2MAIN_LIBRARY})
endif(ENABLE_SDL2)

if(NOT SDL2_FOUND)
	find_package(SDL)
	if(NOT SDL_FOUND)
		message(FATAL_ERROR "SDL library not found!")
	endif(NOT SDL_FOUND)
endif(NOT SDL2_FOUND)

find_package(Math)

find_package(Readline)
if(READLINE_FOUND)
	set(HAVE_LIBREADLINE 1)
endif(READLINE_FOUND)

find_package(ZLIB)
if(ZLIB_FOUND)
	set(HAVE_LIBZ 1)
	set(HAVE_ZLIB_H 1)
endif(ZLIB_FOUND)

find_package(PNG)
if(PNG_FOUND)
	set(HAVE_LIBPNG 1)
endif(PNG_FOUND)

if (NOT ENABLE_OSX_BUNDLE)
	find_package(X11)
	if(X11_FOUND)
		set(HAVE_X11 1)
	endif(X11_FOUND)
endif()

find_package(PortAudio)
if(PORTAUDIO_FOUND)
	set(HAVE_PORTAUDIO 1)
endif(PORTAUDIO_FOUND)

find_package(PortMidi)
if(PORTMIDI_FOUND)
	set(HAVE_PORTMIDI 1)
endif(PORTMIDI_FOUND)

find_package(CapsImage)
if(CAPSIMAGE_FOUND)
	set(HAVE_CAPSIMAGE 1)
endif(CAPSIMAGE_FOUND)

find_package(Udev)
if(UDEV_FOUND)
	set(HAVE_UDEV 1)
endif(UDEV_FOUND)

# Check if Large File Support is available with the standard POSIX flags
set (HATARI_LFS_FLAGS "-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64")
check_large_file()


# ################
# CPP Definitions:
# ################

# Test for large file support:
execute_process(COMMAND getconf LFS_CFLAGS
                OUTPUT_VARIABLE DETECTED_LFS_CFLAGS
                ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
if(DETECTED_LFS_CFLAGS)
	add_definitions(${DETECTED_LFS_CFLAGS})
	# message(STATUS "Large filesystem flags: ${DETECTED_LFS_CFLAGS}")
endif(DETECTED_LFS_CFLAGS)

# Additional CFLAGS suggested by the SDL library:
if(SDL2_FOUND)
	add_definitions(-DWITH_SDL2)
	execute_process(COMMAND pkg-config --cflags-only-other sdl2
			OUTPUT_VARIABLE DETECTED_SDL_CFLAGS
			ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
else(SDL2_FOUND)
	execute_process(COMMAND pkg-config --cflags-only-other sdl
			OUTPUT_VARIABLE DETECTED_SDL_CFLAGS
			ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
endif(SDL2_FOUND)
if(DETECTED_SDL_CFLAGS)
	add_definitions(${DETECTED_SDL_CFLAGS})
	# message(STATUS "Additional CFLAGS of SDL: ${DETECTED_SDL_CFLAGS}")
endif(DETECTED_SDL_CFLAGS)

if(ENABLE_OSX_BUNDLE)
	# Use OSX native alert windows
	add_definitions(-DALERT_HOOKS=1)
	if(SDL2_FOUND)
		# We still want to use our SDLMain.m with SDL2
		add_definitions(-DSDL_MAIN_NEEDED=1)
	endif(SDL2_FOUND)
endif(ENABLE_OSX_BUNDLE)

# ###########################
# Check for optional headers:
# ###########################

check_include_files(termios.h HAVE_TERMIOS_H)
check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(${SDL_INCLUDE_DIR}/SDL_config.h HAVE_SDL_CONFIG_H)
check_include_files(sys/time.h HAVE_SYS_TIME_H)
check_include_files(sys/times.h HAVE_SYS_TIMES_H)
check_include_files(utime.h HAVE_UTIME_H)
check_include_files(sys/utime.h HAVE_SYS_UTIME_H)
check_include_files("sys/socket.h;sys/un.h" HAVE_UNIX_DOMAIN_SOCKETS)

# #############################
# Check for optional functions:
# #############################

check_symbol_exists(cfmakeraw "termios.h" HAVE_CFMAKERAW)
check_symbol_exists(setenv "stdlib.h" HAVE_SETENV)
check_symbol_exists(select "sys/select.h" HAVE_SELECT)
check_symbol_exists(gettimeofday "sys/time.h" HAVE_GETTIMEOFDAY)
check_symbol_exists(nanosleep "time.h" HAVE_NANOSLEEP)
check_symbol_exists(alphasort "dirent.h" HAVE_ALPHASORT)
check_symbol_exists(scandir "dirent.h" HAVE_SCANDIR)
check_symbol_exists(statvfs "sys/statvfs.h" HAVE_STATVFS)
check_symbol_exists(fseeko "stdio.h" HAVE_FSEEKO)
check_symbol_exists(ftello "stdio.h" HAVE_FTELLO)
check_symbol_exists(flock "sys/file.h" HAVE_FLOCK)
check_symbol_exists(strlcpy "string.h" HAVE_LIBC_STRLCPY)
check_struct_has_member("struct dirent" d_type dirent.h HAVE_DIRENT_D_TYPE)

# #############
# Other CFLAGS:
# #############

# GCC pointer debugging, huge run-time slowdown
if(ENABLE_MUDFLAP)
	# SDL mixer threads so have to use threaded mudflap version
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fstack-protector-all -fmudflapth")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fmudflapth -lmudflap")
endif(ENABLE_MUDFLAP)

# GCC/Clang specific flags:
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
	# We want to allow ‘for’-loop initial declarations a la for(int i=0; ...)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
	# Warning flags:
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-qual -Wbad-function-cast -Wpointer-arith")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes -Wstrict-prototypes")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wwrite-strings -Wsign-compare")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wextra -Wno-unused-parameter -Wno-empty-body")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat-security")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow -D_FORTIFY_SOURCE=2 -Werror")
endif()

# Building Hatari w/o optimization is no fun...
IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
	set(CMAKE_C_FLAGS "-O ${CMAKE_C_FLAGS}")
ENDIF (CMAKE_BUILD_TYPE STREQUAL "Debug")

# Always add the Large File Support flags in case they are supported
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${HATARI_LFS_FLAGS}")


# ####################
# Paths configuration:
# ####################

if(NOT BINDIR)
	set(BINDIR bin)
endif()

if(NOT DATADIR)
	set(DATADIR share/hatari)
endif()

if(NOT BIN2DATADIR)
	if(WIN32)
		set(BIN2DATADIR "."
		    CACHE STRING "Relative path from bindir to datadir")
	elseif(ENABLE_OSX_BUNDLE)
		set(BIN2DATADIR "../Resources"
		    CACHE STRING "Relative path from bindir to datadir")
	else()
		set(BIN2DATADIR "../share/hatari"
		    CACHE STRING "Relative path from bindir to datadir")
	endif(WIN32)
	mark_as_advanced(BIN2DATADIR)
endif()

if(NOT MANDIR)
	set(MANDIR share/man/man1)
endif()

if(NOT DOCDIR)
	set(DOCDIR share/doc/hatari)
endif()

if(NOT ETCDIR)
	if(WIN32)
		set(ETCDIR .)
	else()
		set(ETCDIR /etc)
	endif()
endif()

if(NOT ICONDIR)
	set(ICONDIR share/icons/hicolor)
endif()

if(ENABLE_OSX_BUNDLE)
	# put the config files in the app's bundle
	add_definitions(-DCONFDIR=\"../Resources\")
else()
	add_definitions(-DCONFDIR=\"${ETCDIR}\")
endif()

# #########################################
# Create config.h and recurse into subdirs:
# #########################################

configure_file(${CMAKE_SOURCE_DIR}/cmake/config-cmake.h
		${CMAKE_BINARY_DIR}/config.h)

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(tests)
add_subdirectory(tools)

include(FindPythonInterp)
if(PYTHONINTERP_FOUND)
	add_subdirectory(python-ui)
endif(PYTHONINTERP_FOUND)

if(UNIX AND NOT ENABLE_OSX_BUNDLE)
	add_subdirectory(share)
endif()

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/cmake/Uninstall.cmake)


# ###################################################################
# Print a summary of the optional libraries with a short explanation:
# ###################################################################

message( "
Libraries summary :
-------------------
")

if(SDL2_FOUND)
  message("  - sdl :\tusing SDL2 v${SDL2_VERSION_STRING}")
else()
  if(SDL_VERSION_STRING)
    message("  - sdl :\tusing SDL v${SDL_VERSION_STRING}")
  else()
    message("  - sdl :\tusing SDL1")
  endif(SDL_VERSION_STRING)
  message("         \tNOTE: The SDL1 support is deprecated and will be removed soon")
endif(SDL2_FOUND)

if(READLINE_FOUND)
  message( "  - readline :\tfound, enables history/completion in the debugger" )
else()
  message( "  - readline :\tnot found, install it to enable debugger history/completion" )
endif(READLINE_FOUND)

if(ZLIB_FOUND)
  message( "  - zlib :\tfound, allows to use zip/gz files directly" )
else()
  message( "  - zlib :\tnot found, install it to use zip/gz files" )
endif(ZLIB_FOUND)

if(PNG_FOUND)
  message( "  - png :\tfound, allows to compress screenshot/avi files using png" )
else()
  message( "  - png :\tnot found, install it to compress screenshot/avi files using png" )
endif(PNG_FOUND)

if(PORTAUDIO_FOUND)
  message( "  - portaudio :\tfound, enables the microphone input in Falcon mode" )
else()
  message( "  - portaudio :\tnot found, install it to enable the Falcon microphone input" )
endif(PORTAUDIO_FOUND)

if(PORTMIDI_FOUND)
  message( "  - portmidi :\tfound, required for (non-Linux) MIDI support" )
else()

=== python-ui/CMakeLists.txt ===
# conftypes.py is created to source directory (instead of build directory)
# so that Hatari UI can be tested directly from the source directory
add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/conftypes.py
	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/gentypes.py < ${CMAKE_CURRENT_SOURCE_DIR}/../src/configuration.c > ${CMAKE_CURRENT_SOURCE_DIR}/conftypes.py
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../src/configuration.c ${CMAKE_CURRENT_SOURCE_DIR}/gentypes.py)
add_custom_target(conftypes ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/conftypes.py)

INSTALL(PROGRAMS hatariui
	DESTINATION ${BINDIR})

INSTALL(PROGRAMS hatariui.py debugui.py
	DESTINATION ${DATADIR}/hatariui/)

INSTALL(FILES README TODO release-notes.txt hatari-icon.png hatari-logo.png
	config.py dialogs.py hatari.py uihelpers.py
	${CMAKE_CURRENT_SOURCE_DIR}/conftypes.py
	DESTINATION ${DATADIR}/hatariui/)

INSTALL(FILES hatariui.desktop
	DESTINATION share/applications)

# if(UNIX)
	add_custom_target(hatariui_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hatariui.1 > ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz
		DEPENDS hatariui.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hatariui.1.gz DESTINATION ${MANDIR})
# endif(UNIX)

=== src/CMakeLists.txt ===

set(SOURCES
	acia.c audio.c avi_record.c bios.c blitter.c cart.c cfgopts.c
	clocks_timings.c configuration.c options.c change.c control.c
	cycInt.c cycles.c dialog.c dmaSnd.c fdc.c file.c floppy.c
	floppy_ipf.c floppy_stx.c gemdos.c hd6301_cpu.c hdc.c ide.c ikbd.c
	ioMem.c ioMemTabST.c ioMemTabSTE.c ioMemTabTT.c ioMemTabFalcon.c joy.c
	keymap.c m68000.c main.c midi.c memorySnapShot.c mfp.c nf_scsidrv.c
	ncr5380.c paths.c  psg.c printer.c resolution.c rs232.c reset.c rtc.c
	scandir.c scc.c stMemory.c screen.c screenConvert.c screenSnapShot.c
	shortcut.c sound.c spec512.c statusbar.c str.c tos.c utils.c
	vdi.c inffile.c video.c wavFormat.c xbios.c ymFormat.c)

# Disk image code is shared with the hmsa tool, so we put it into a library:
add_library(Floppy createBlankImage.c dim.c msa.c st.c zip.c)

# When building for macOS, define specific sources for gui and ressources
if(ENABLE_OSX_BUNDLE)
	set(GUIOSX_SOURCES
	    gui-osx/AlertHooks.m gui-osx/PrefsController.m gui-osx/Shared.m
	    gui-osx/CreateFloppyController.m gui-osx/SDLMain.m gui-osx/paths.m)
	set_source_files_properties(${GUIOSX_SOURCES} PROPERTIES LANGUAGE C)
	set(GUIOSX_RSRCS
	    gui-osx/Hatari.icns gui-osx/stdisk.png gui-osx/en.lproj gui-osx/fr.lproj)
	set(GUIOSX_DOCS
	    ${CMAKE_SOURCE_DIR}/doc/manual.html ${CMAKE_SOURCE_DIR}/doc/images
	    ${CMAKE_SOURCE_DIR}/doc/compatibility.html ${CMAKE_SOURCE_DIR}/doc/toc.js )
	# these are the macOS Interface Builder Files
	set (HATARI_XIBS en.lproj/SDLMain fr.lproj/SDLMain)
endif(ENABLE_OSX_BUNDLE)

# When building for Windows, define specific sources for gui and resources
# and set the subsystem of the resulting .exe to "windows GUI" instead of "console"
if(WIN32)
	set(GUIWIN_SOURCES gui-win/opencon.c)
	set(GUIWIN_RES gui-win/hatari-winicon.rc)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mwindows")
endif(WIN32)

if(ENABLE_WINUAE_CPU)
	set(CPUDIR cpu)
else()
	set(CPUDIR uae-cpu)
endif(ENABLE_WINUAE_CPU)

include_directories(includes debug falcon
		    ${CMAKE_BINARY_DIR} ${SDL_INCLUDE_DIR} ${CPUDIR})

if(ZLIB_FOUND)
	include_directories(${ZLIB_INCLUDE_DIR})
	set(SOURCES ${SOURCES} unzip.c)
endif(ZLIB_FOUND)

if(PNG_FOUND)
	include_directories(${PNG_INCLUDE_DIR})
endif(PNG_FOUND)

if(X11_FOUND)
	include_directories(${X11_INCLUDE_DIR})
endif(X11_FOUND)


link_directories(${CMAKE_CURRENT_BINARY_DIR}/debug
		 ${CMAKE_CURRENT_BINARY_DIR}/falcon
		 ${CMAKE_CURRENT_BINARY_DIR}/gui-sdl
		 ${CMAKE_CURRENT_BINARY_DIR}/${CPUDIR})

add_subdirectory(debug)
add_subdirectory(falcon)
add_subdirectory(gui-sdl)
add_subdirectory(${CPUDIR})

# When building for macOS, add specific sources
if(ENABLE_OSX_BUNDLE)
	#find_library(SDL_FRAMEWORK SDL ${ADD_FRAMEWOK_PATH})
	set(ADDITIONAL_INCLUDES ${FRAMEWORKS})
	set_source_files_properties(${FRAMEWORKS} PROPERTIES MACOSX_PACKAGE_LOCATION Frameworks)
	add_executable(hatari MACOSX_BUNDLE ${GUIOSX_RSRCS} ${GUIOSX_DOCS} ${SOURCES} ${GUIOSX_SOURCES} ${FRAMEWORKS})
	set_target_properties(hatari PROPERTIES MACOSX_BUNDLE_INFO_PLIST
			      ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/Info-Hatari.plist)
	set(MACOSX_BUNDLE_ICON_FILE Hatari.icns)
	if(CMAKE_GENERATOR MATCHES "Xcode")
		set(BUNDLE_CONTENTS ${CMAKE_CURRENT_BINARY_DIR}/\${CONFIGURATION}/Hatari.app/Contents)
	else()
		set(BUNDLE_CONTENTS ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents)
	endif()
	# Create Hatari.app bundle
	add_custom_target(osx_bundle_dirs
			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources
			#COMMAND mkdir -p ${BUNDLE_CONTENTS}/Frameworks
			COMMAND mkdir -p ${BUNDLE_CONTENTS}/MacOS
			COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${MACOSX_BUNDLE_ICON_FILE}
				   ${BUNDLE_CONTENTS}/Resources/${MACOSX_BUNDLE_ICON_FILE}
			# Copy Localized .nib and help to Bundle
			COMMAND cp -R ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/*.lproj ${BUNDLE_CONTENTS}/Resources/
			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/HatariHelp
			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/HatariHelp/
			#COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp
			#COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp/
	)
	add_dependencies(hatari osx_bundle_dirs)
	set_source_files_properties(${GUIOSX_RSRCS} PROPERTIES
				    MACOSX_PACKAGE_LOCATION Resources)
	set_source_files_properties(${GUIOSX_DOCS} PROPERTIES
				    MACOSX_PACKAGE_LOCATION Resources/HatariHelp)

	#find ibtool
	find_program(IBTOOL ibtool HINTS "/usr/bin" "${OSX_DEVELOPER_ROOT}/usr/bin")
	if (${IBTOOL} STREQUAL "IBTOOL-NOTFOUND")
		message(SEND_ERROR "ibtool can not be found and is needed to compile the .xib files.
			It should have been installed with the Apple developer tools. The default
			system paths were searched in addition to ${OSX_DEVELOPER_ROOT}/usr/bin")
	endif()
	# Compile the .xib files using the 'ibtool' program with the destination being the app package
	foreach(xib ${HATARI_XIBS})
		add_custom_command (TARGET hatari POST_BUILD
			COMMAND ${IBTOOL} --errors --warnings --notices --output-format human-readable-text
				--compile ${BUNDLE_CONTENTS}/Resources/${xib}.nib ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${xib}.xib
			COMMAND rm ${BUNDLE_CONTENTS}/Resources/${xib}.xib
			COMMENT "Compiling ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${xib}.xib")
	endforeach()

# When building for Windows, add specific sources + method to compile .rc files
elseif(WIN32)
	# Set a default rc compiler if it was not defined yet
	if(NOT CMAKE_RC_COMPILER)
		set(CMAKE_RC_COMPILER windres)
	endif(NOT CMAKE_RC_COMPILER)
	ENABLE_LANGUAGE(RC)
	set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> -Ocoff -o <OBJECT> <SOURCE>")
	set_source_files_properties(${GUIWIN_RES} PROPERTIES LANGUAGE RC)
	add_executable(hatari ${GUIWIN_RES} ${SOURCES} ${GUIWIN_SOURCES})

# Other targets, use default sources
else()
	add_executable(hatari ${SOURCES})
endif(ENABLE_OSX_BUNDLE)

target_link_libraries(hatari Falcon UaeCpu GuiSdl Floppy Debug ${SDL_LIBRARY})

if(MATH_FOUND AND NOT APPLE)
	target_link_libraries(hatari ${MATH_LIBRARY})
endif()

if(SDLMAIN_LIBRARY)
	target_link_libraries(hatari ${SDLMAIN_LIBRARY})
endif(SDLMAIN_LIBRARY)

if(READLINE_FOUND)
	target_link_libraries(hatari ${READLINE_LIBRARY})
endif(READLINE_FOUND)

if(ZLIB_FOUND)
	target_link_libraries(hatari ${ZLIB_LIBRARY})
endif(ZLIB_FOUND)

if(PNG_FOUND)
	target_link_libraries(hatari ${PNG_LIBRARY})
endif(PNG_FOUND)

if(X11_FOUND)
	target_link_libraries(hatari ${X11_LIBRARIES})
endif(X11_FOUND)

if(PORTAUDIO_FOUND)
	target_link_libraries(hatari ${PORTAUDIO_LIBRARY})
endif(PORTAUDIO_FOUND)

if(PORTMIDI_FOUND)
	target_link_libraries(hatari ${PORTMIDI_LIBRARY})
endif(PORTMIDI_FOUND)

if(CAPSIMAGE_FOUND)
	target_link_libraries(hatari ${CAPSIMAGE_LIBRARY})
endif(CAPSIMAGE_FOUND)

if(UDEV_FOUND)
	target_link_libraries(hatari ${UDEV_LIBRARY})
endif(UDEV_FOUND)

if(WIN32)
	# Needed for socket() on Windows
	target_link_libraries(hatari ws2_32)
endif(WIN32)


if(ENABLE_OSX_BUNDLE)
	install(TARGETS hatari BUNDLE DESTINATION /Applications)
else()
	install(TARGETS hatari RUNTIME DESTINATION ${BINDIR})
	install(FILES hatari-icon.bmp DESTINATION ${DATADIR})
	file(GLOB TOS_IMG_FILE tos.img)
	if(TOS_IMG_FILE)
		install(FILES tos.img DESTINATION ${DATADIR})
	endif(TOS_IMG_FILE)
endif(ENABLE_OSX_BUNDLE)

=== tests/CMakeLists.txt ===

add_subdirectory(debugger)

if(UNIX)
	add_test(NAME config-file COMMAND
	         ${CMAKE_CURRENT_SOURCE_DIR}/configfile.sh $<TARGET_FILE:hatari>)
	add_subdirectory(buserror)
	add_subdirectory(cpu)
	add_subdirectory(cycles)
	add_subdirectory(natfeats)
	add_subdirectory(serial)
	add_subdirectory(xbios)
endif(UNIX)

=== src/uae-cpu/CMakeLists.txt ===

include_directories(. ../.. ../includes ${SDL_INCLUDE_DIR})

# Unfortunately we've got to specify the rules for the generated files twice,
# once for cross compiling (with calling the host cc directly) and once
# for native compiling so that the rules also work for non-Unix environments...
if(CMAKE_CROSSCOMPILING)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/build68k
		COMMAND cc ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c
		           -o ${CMAKE_CURRENT_BINARY_DIR}/build68k
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND ./build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/table68k
			${CMAKE_CURRENT_BINARY_DIR}/build68k)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		COMMAND cc -I${CMAKE_CURRENT_SOURCE_DIR}
			   cpudefs.c ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			   ${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c
			   -o ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c cpudefs.c)

	add_custom_command(OUTPUT cpuemu.c cpustbl.c
		COMMAND ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gencpu)

else()	# Rules for normal build follow

	add_executable(build68k build68k.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS table68k build68k)

	add_executable(gencpu gencpu.c readcpu.c cpudefs.c)

	add_custom_command(OUTPUT cpuemu.c cpustbl.c COMMAND gencpu DEPENDS gencpu)

endif(CMAKE_CROSSCOMPILING)


# Generated cpuemu.c contains a lot of warnings we don't really care about...
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-compare -Wno-shadow")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-variable -Wno-unused-label")
endif(CMAKE_COMPILER_IS_GNUCC)

add_library(UaeCpu
	cpudefs.c cpuemu.c cpustbl.c
	hatari-glue.c memory.c newcpu.c readcpu.c fpp.c
	)

=== tests/buserror/CMakeLists.txt ===

set(testrunner ${CMAKE_CURRENT_SOURCE_DIR}/run_test.sh)

foreach(machine st megast ste megaste tt falcon)
 add_test(NAME buserror-${machine}-b COMMAND ${testrunner} $<TARGET_FILE:hatari> b ${machine})
 add_test(NAME buserror-${machine}-w COMMAND ${testrunner} $<TARGET_FILE:hatari> w ${machine})
endforeach(machine)

=== tests/natfeats/CMakeLists.txt ===

set(testrunner ${CMAKE_CURRENT_SOURCE_DIR}/run_test.sh)

if(ENABLE_WINUAE_CPU)

 foreach (lvl RANGE 0 4)
  add_test(NAME natfeats-680${lvl}0-fast
           COMMAND ${testrunner} $<TARGET_FILE:hatari> --cpulevel ${lvl} --compatible false --cpu-exact false)
  add_test(NAME natfeats-680${lvl}0-compatible
           COMMAND ${testrunner} $<TARGET_FILE:hatari> --cpulevel ${lvl} --compatible true --cpu-exact false)
  add_test(NAME natfeats-680${lvl}0-cpuexact
           COMMAND ${testrunner} $<TARGET_FILE:hatari> --cpulevel ${lvl} --compatible false --cpu-exact true)
  if (${lvl} GREATER 2)
  add_test(NAME natfeats-680${lvl}0-mmu
           COMMAND ${testrunner} $<TARGET_FILE:hatari> --cpulevel ${lvl} --mmu true)
  endif()
 endforeach(lvl)
 add_test(NAME natfeats-68060
          COMMAND ${testrunner} $<TARGET_FILE:hatari> --cpulevel 6 --mmu false)
 add_test(NAME natfeats-68060-mmu
          COMMAND ${testrunner} $<TARGET_FILE:hatari> --cpulevel 6 --mmu true)

else(ENABLE_WINUAE_CPU)

 foreach (lvl RANGE 0 4)
  add_test(NAME natfeats-680${lvl}0-fast
           COMMAND ${testrunner} $<TARGET_FILE:hatari> --cpulevel ${lvl} --compatible false)
  add_test(NAME natfeats-680${lvl}0-compatible
           COMMAND ${testrunner} $<TARGET_FILE:hatari> --cpulevel ${lvl} --compatible true)
 endforeach(lvl)

endif(ENABLE_WINUAE_CPU)

=== debian/changelog ===
hatari (2.2.1+dfsg-1) unstable; urgency=medium

  * Import upstream version 2.2.1 (Closes: 923833)
  * Bump debhelper compatibility level to 12
  * Add Rules-Requires-Root: no
  * Build with python3, force python3 shebang
  * Drop 03-fix-py-extension, applied upstream
  * Add new patch fixing installation of python-ui documentation
  * Update copyright information
  * Update README.Debian, WinUAE CPU core is now the default
  * Bump standards-version, no changes required
  * Add patch for using py3 for gentypes during build
  * Run wrap-and-sort -at
  * Disable test suite for now

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 22 Dec 2019 21:07:46 +0100
